function examTDMNBA14(gr)

% Fonction de corrig de l'examen de TD de Janvier 2015
% ATTENTION, la fonction examTDMNBA14 ne marchent que si sont prsentes les deux fonctions
% * diff_div
% * eval_horner
% qui proviennent de l'ouvrage suivant :
% Jrme Bastien et  Jean-Nol Martin
% Introduction  l'analyse numrique,
% Applications sous Matlab
% Dunod
% 2003
% Ouvrage disponible  la bibliothque Sciences de Lyon 1 (cote : 519.4~BAS, 4 ime tage)
%
% entre optionnelle gr=1 pour le sujet donn chronologiquement en premier
% et 2 pour celui donn en second. Vide vaut 1 par dfaut.
% Tapez donc l'une des trois commandes suivantes :
% examTDMNBA14
% examTDMNBA14(1)
% examTDMNBA14(2)

if nargin==0|isempty(gr)
    gr=1;
end

% copi-coll du fichier matex de l'exo 1
%\Debutmatscript
if gr==1
    % facile
    F=@(x) cos(x);
    A=1;
    B=2;
    N=6;
    epsi=1e-2;
    K=1/12;
    alphaa=2;
    resI=trapezc(A,B,N,F);
else
    % difficile
    F=@(x) sin(x);
    A=0;
    B=1;
    N=3;
    epsi=1e-8;
    K=1/2880;
    alphaa=4;
    resI=simpsonc(A,B,N,F);
end
Nb=ceil((K*(B-A)^(alphaa+1)/epsi)^(1/alphaa));
syms a b t;
Iexa=int(F(t),t,A,B);
erreurpost=abs(eval(Iexa)-resI);
c=(a+b)/2;
fa=sym('f(a)');
fb=sym('f(b)');
fc=sym('f(c)');
X=[a,b,c];
Y=[fa,fb,fc];
D=cell(1,2);
Z=cell(1,2);
Zi=Z;
for q=1:2
    D{q}=diff_div(X(1:q+1),Y(1:q+1));
    C=X(1:q);
    Z{q}=eval_horner(t,C,D{q});
    Zi{q}=simplify(int(Z{q},t,a,b));
end
if gr==1
    D{2}=[D{2},0];
end
%\Finmatscript

% copi-coll du fichier matex de l'exo 2
%\Debutmatscript
ft=sym('f(t)');
fpt=diff(ft,t);
d=a;
% faire plus malin ??
fd=subs(fpt,t,a);
if gr==1
    % facile
    Dn=diff_div([a,a,b],[fa,fd,fb]);
    Cn=[a,a];
    R=int((t-a)*(t-b),t,a,b);
else
    % Difficile
    Dn=diff_div([a,a,c,b],[fa,fd,fc,fb]);
    Cn=[a,a,c];
    R=int((t-a)*(t-b)*(t-c),t,a,b);
end
Zn=eval_horner(t,Cn,Dn);
Zin=simplify(int(Zn,t,a,b));
Fp=inline(vectorize(char(diff(F(t),t))));
h=(B-A)/N;
x=[A,A+h:h:B-h];
resIb=2/3*h*F(A)+1/3*h*F(B)+h*sum(F(x(2:end)))+h^2/6*sum(Fp(x(1:end)));
erreurpostb=abs(eval(Iexa)-resIb);
%\Finmatscript


%% exercice 1
disp('exercice 1');
disp(' ');
disp('Question 1)');
disp('Diffrences divises');
DD=D{2};
pretty(DD(1));
pretty(DD(2));
pretty(DD(3));
disp('p_1');
pretty(Z{1});
disp('p_2');
pretty(Z{2});
disp('Question 2)');
disp(['Intgrale de p_',int2str(gr)]);
pretty(Zi{gr});
disp('Question 4)');
disp('Intgrale approche');
disp(resI);
disp('Intgrale exacte');
disp(Iexa);
disp(eval(Iexa));
disp('Diffrence');
disp(erreurpost);
disp('Question 5)');
disp('N');
disp(Nb);
disp('Appuyez sur une touche pour continuer');
pause;



%% exercice 2
disp('exercice 2');
disp(' ');
disp('Question 1)');
disp('Diffrence divise supplmentaire');
pretty(Dn(end));
disp('Question 2)');
disp(['p_',int2str(gr),'(a)']);
disp(simplify(subs(Zn,t,a)));
disp(['p_',int2str(gr),'(b)']);
disp(simplify(subs(Zn,t,b)));
if gr==2
    disp(['p_',int2str(gr),'(c)']);
    disp(simplify(subs(Zn,t,c)));
end
disp(['p_''',int2str(gr),'(a)']);
disp(simplify(subs(diff(Zn,t),t,a)));
disp('Terme en plus dans l''intgrale du polynme');
disp('Question 3)');
pretty(simplify(R)*simplify(Dn(end)));
disp('Deux faons de calculer l''intgrale du polynome');
disp('Celle suggre par l''nonc (plus rapide) : ');
pretty(Zi{gr}+simplify(R)*simplify(Dn(end)));
disp('L''autre o l''on recalcule tout : ');
pretty(simplify(Zin));
disp('Diffrence des deux : ');
disp(simplify(Zin-Zi{gr}-R*Dn(end)));
disp('Question 4)');
if gr==2
    disp('Cette question tait un pige puisque les deux formules taient identiques !');
else
    disp('Intgrale approche');
    disp(resIb);
    disp('Diffrence');
    disp(erreurpostb);
    if gr==1
        Nm=100;
        %Nm=10;
        Ntot=fliplr(sort(unique(fix(logspace(1,4,Nm)))));
        Nm=length(Ntot);
        Er=zeros(1,Nm);
        H=Er;
        evalIexa=eval(Iexa);
        for i=1:Nm
            h=(B-A)/Ntot(i);
            x=[A,A+h:h:B-h];
            Er(i)=abs(2/3*h*F(A)+1/3*h*F(B)+h*sum(F(x(2:end)))+h^2/6*sum(Fp(x(1:end)))-evalIexa);
            H(i)=h;
        end
        clf;
        loglog(H,Er);
        Q=polyfit(log10(H),log10(Er),1);
        ordre=Q(1);
    else
        ordre=0;
    end
    disp('ordre');
    disp(ordre);
end